//+------------------------------------------------------------------+
//|                              Copyright  2009-2012, Shawn Harris |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "V1.0 Copyright  2001-2012, JediFX, Shawn Harris"
#property link      "http://www.jediforex.com"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow

//#property indicator_color2 Red
//#property indicator_color3 DodgerBlue
   
#define COEF_ROOT 50.14348112  
#define COEF_EUR -0.576
#define COEF_GBP -0.119
#define COEF_JPY 0.136
#define COEF_CAD 0.091
#define COEF_CHF 0.036
#define COEF_SEK 0.042

#define SYM_EUR "EURUSD"
#define SYM_GBP "GBPUSD"
#define SYM_JPY "USDJPY"
#define SYM_CAD "USDCAD"
#define SYM_CHF "USDCHF"
#define SYM_SEK "USDSEK"

extern bool  ShowLineChart = false;
extern bool  ShowCandles   = false;
extern color BullWick = Blue;
extern color BullBody = DodgerBlue;
extern color BearWick = FireBrick;
extern color BearBody = Red;
extern color Doji = Gold;

double NDXCLOSE[];
double NDXOPEN[];
double NDXHIGH[];
double NDXLOW[];

string name = "$$USDX";
string suffix = "";
string shortName;

int Window = 0;

int init() 
{
   Window = 0;
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, NDXCLOSE);
   if (!ShowLineChart)
      SetIndexStyle(0, DRAW_NONE);

   SetIndexStyle(1, DRAW_NONE);
   SetIndexBuffer(1, NDXOPEN);

   SetIndexStyle(2, DRAW_NONE);
   SetIndexBuffer(2, NDXHIGH);

   SetIndexStyle(3, DRAW_NONE);
   SetIndexBuffer(3, NDXLOW);

   suffix = StringSubstr(Symbol(), 6, 16);

   shortName = name;      
   IndicatorShortName(shortName);
   
   return (0);
}


int deinit() 
{
   if (Window > 0)
      ObjectsDeleteAll(Window);
   return (0);
}


int start() 
{
   int counted = IndicatorCounted();
   
   if (counted < 0) 
      return (-1);
   
   if (counted > 0) 
      counted--;
   
   int limit = Bars - counted;
   
   double o, c, h, l;

   RefreshSym(SYM_EUR + suffix);
   RefreshSym(SYM_GBP + suffix);
   RefreshSym(SYM_JPY + suffix);
   RefreshSym(SYM_CAD + suffix);
   RefreshSym(SYM_CHF + suffix);
   RefreshSym(SYM_SEK + suffix);
      
   if (Window == 0) {
      Window = WindowFind(shortName);
   }
         
   for (int i = limit; i >=0; i--)  {
      NDXCLOSE[i] = EMPTY_VALUE;
      NDXOPEN[i]  = EMPTY_VALUE;
      NDXHIGH[i]  = EMPTY_VALUE;
      NDXLOW[i]   = EMPTY_VALUE;
      
      o = COEF_ROOT 
      * NonZero(MathPow(iOpen(SYM_EUR + suffix, Period(), i), COEF_EUR))
      * NonZero(MathPow(iOpen(SYM_GBP + suffix, Period(), i), COEF_GBP)) 
      * NonZero(MathPow(iOpen(SYM_JPY + suffix, Period(), i), COEF_JPY)) 
      * NonZero(MathPow(iOpen(SYM_CAD + suffix, Period(), i), COEF_CAD)) 
      * NonZero(MathPow(iOpen(SYM_CHF + suffix, Period(), i), COEF_CHF))
      * NonZero(MathPow(iOpen(SYM_SEK + suffix, Period(), i), COEF_SEK)); 
      
      if (i != 0) {
         c = COEF_ROOT 
         * NonZero(MathPow(iClose(SYM_EUR + suffix, Period(), i), COEF_EUR))
         * NonZero(MathPow(iClose(SYM_GBP + suffix, Period(), i), COEF_GBP)) 
         * NonZero(MathPow(iClose(SYM_JPY + suffix, Period(), i), COEF_JPY)) 
         * NonZero(MathPow(iClose(SYM_CAD + suffix, Period(), i), COEF_CAD)) 
         * NonZero(MathPow(iClose(SYM_CHF + suffix, Period(), i), COEF_CHF))
         * NonZero(MathPow(iClose(SYM_SEK + suffix, Period(), i), COEF_SEK)); 
      }
      else {
         c = COEF_ROOT 
         * NonZero(MathPow(iMA(SYM_EUR + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_EUR))
         * NonZero(MathPow(iMA(SYM_GBP + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_GBP)) 
         * NonZero(MathPow(iMA(SYM_JPY + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_JPY)) 
         * NonZero(MathPow(iMA(SYM_CAD + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_CAD)) 
         * NonZero(MathPow(iMA(SYM_CHF + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_CHF))
         * NonZero(MathPow(iMA(SYM_SEK + suffix, Period(), 1, 0, MODE_EMA, PRICE_CLOSE, i), COEF_SEK)); 
      }
      
      h = COEF_ROOT 
      * NonZero(MathPow(iHigh(SYM_EUR + suffix, Period(), i), COEF_EUR))
      * NonZero(MathPow(iHigh(SYM_GBP + suffix, Period(), i), COEF_GBP)) 
      * NonZero(MathPow(iHigh(SYM_JPY + suffix, Period(), i), COEF_JPY)) 
      * NonZero(MathPow(iHigh(SYM_CAD + suffix, Period(), i), COEF_CAD)) 
      * NonZero(MathPow(iHigh(SYM_CHF + suffix, Period(), i), COEF_CHF))
      * NonZero(MathPow(iHigh(SYM_SEK + suffix, Period(), i), COEF_SEK)); 
    
      l = COEF_ROOT 
      * NonZero(MathPow(iLow(SYM_EUR + suffix, Period(), i), COEF_EUR))
      * NonZero(MathPow(iLow(SYM_GBP + suffix, Period(), i), COEF_GBP)) 
      * NonZero(MathPow(iLow(SYM_JPY + suffix, Period(), i), COEF_JPY)) 
      * NonZero(MathPow(iLow(SYM_CAD + suffix, Period(), i), COEF_CAD)) 
      * NonZero(MathPow(iLow(SYM_CHF + suffix, Period(), i), COEF_CHF))
      * NonZero(MathPow(iLow(SYM_SEK + suffix, Period(), i), COEF_SEK));  

      if (h < l) {
         double t = h;
         h = l;
         l = t;
      }
      
      if (o < c) {
         if (l > o)
            l = o;
         if (h < c)
            h = c;
      }
      else if (o > c) {
         if (l > c)
            l = c;
         if (h < o)
            h = o;
      }
      
      NDXCLOSE[i] = NormalizeDouble(c, 5);
      NDXOPEN[i]  = NormalizeDouble(o, 5);
      NDXHIGH[i]  = NormalizeDouble(h, 5);
      NDXLOW[i]   = NormalizeDouble(l, 5);      
      
      if (ShowCandles)      
         PlotCandle(o, c, h, l, i);
   }
   
   return (0);
}


double NonZero(double in)
{
   if (in == 0)
      return (1);
      
   return (in);
}


void RefreshSym(string s)
{
   int hbars = 0;
   while (hbars == 0) {
      hbars = iBars(s, Period());
      if (hbars > 0) {
         break;
         
      }    
      
      int err = GetLastError();
      
      if (err != 4066) {
         // ERR_HISTORY_WILL_UPDATED   4066   Requested history data in updating state.
         break;
      } 
      else {
         Sleep(2000); 
      }
   }
}


void PlotCandle(double o, double c, double h, double l, int bar)
{
   if (Window <= 0)
      return;
      
   string nameb = "PCANDB" + Time[bar];
   string namew = "PCANDW" + Time[bar];
   
   ObjectCreate(namew, OBJ_TREND, Window, Time[bar], h, Time[bar], l);  
   ObjectCreate(nameb, OBJ_TREND, Window, Time[bar], o, Time[bar], c);     
   
   ObjectSet(nameb, OBJPROP_RAY, false);
   ObjectSet(namew, OBJPROP_RAY, false);
   ObjectSet(namew, OBJPROP_BACK, true);
   
   ObjectSet(nameb, OBJPROP_WIDTH, 5);
   ObjectSet(namew, OBJPROP_WIDTH, 1);
   
   if (o < c) {
      ObjectSet(nameb, OBJPROP_COLOR, BullBody);
      ObjectSet(namew, OBJPROP_COLOR, BullWick);
      ObjectSet(nameb, OBJPROP_PRICE1, o);
      ObjectSet(nameb, OBJPROP_PRICE2, c);
      ObjectSet(namew, OBJPROP_PRICE1, h);
      ObjectSet(namew, OBJPROP_PRICE1, l);
   }
   else if (o > c) {
      ObjectSet(nameb, OBJPROP_COLOR, BearBody);
      ObjectSet(namew, OBJPROP_COLOR, BearWick);
      ObjectSet(nameb, OBJPROP_PRICE1, c);
      ObjectSet(nameb, OBJPROP_PRICE2, o);
      ObjectSet(namew, OBJPROP_PRICE1, l);
      ObjectSet(namew, OBJPROP_PRICE1, h);
   }
   else {
      ObjectSet(nameb, OBJPROP_COLOR, Doji);
      ObjectSet(namew, OBJPROP_COLOR, Doji);
   }
}


